.486p					;486 instruction set enable
.model flat, stdCALL  

;extrn	ExitProcess : PROC
;extrn	RtlMoveMemory : PROC

Comment % MD5 - My very little simple implemantation ;)
In the main procedure (MD5_Transform), there is no jmp/call !
Written by Lucifer48 [PC]

History:
-------
v1.1	(August, 15th 2001) - MD5_Pad function rewritten
v1.0	(August, 9th 2001) - first version

(see the RFC 1321 for more details)

4 functions:
* MD5_Init
* MD5_Pad
* MD5_Transform
* MD5_Compute	<- main function

	%

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
	.data
padding	db	80h, 63 dup(0)
nbloop	dd	0			;number (-1 or -2) of loop (block of 512-bit processing).
					;the last 512-bit block is located at (offset lastblock)
	.data?	
lastblock	db 64 dup(?)		;last 512-bit block after padding
		db 64 dup(?)		;if length (mod 64) > 55 then another 512-bit block is required
					;// example: length = 59 ; pad = 61 ; 64-bit length representation = 8
					;// which makes two blocks: 59+5 AND 56+8
lastblock_use	dd ?			;use the second lastblock ?

a	dd ?	;state
b	dd ?
c	dd ?
d	dd ?

save_a	dd ?
save_b	dd ?
save_c	dd ?
save_d	dd ?

lengt	dq ?				;64-bit representation of the messages length (before padding bits were added)

;some values for rol
	S11	equ 7
	S12	equ 12
	S13	equ 17
	S14	equ 22
	S21	equ 5
	S22	equ 9
	S23	equ 14
	S24	equ 20
	S31	equ 4
	S32 	equ 11
	S33 	equ 16
	S34 	equ 23
	S41	equ 6
	S42 	equ 10
	S43	equ 15
	S44 	equ 21

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
	.code

;*******************************************************************
;* Eight important macros					   *
;*******************************************************************
F	MACRO					;F(X,Y,Z) = XY v not(X) Z
	and	ecx, eax			;eax = X
	not	eax				;ecx = Y
	and	eax, edx			;edx = Z
	or	eax, ecx	
	ENDM

;/* Let [abcd k s i] denote the operation a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
FF	MACRO	_a, _b, _c, _d, xk, s, ti	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F
	add	eax, _a
	add	eax, xk
	add	eax, ti
	mov	ecx, s
	rol	eax, cl
	add	eax, _b
	mov	_a, eax
	ENDM

G	MACRO 					;G(X,Y,Z) = XZ v Y not(Z)
	and	eax, edx			;eax = X
	not	edx				;ecx = Y
	and	ecx, edx			;edx = Z
	or	eax, ecx	
	ENDM

;/* Let [abcd k s i] denote the operation a = b + ((a + G(b,c,d) + X[k] + T[i]) <<< s). */
GG	MACRO	_a, _b, _c, _d, xk, s, ti	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	G
	add	eax, _a
	add	eax, xk
	add	eax, ti
	mov	ecx, s
	rol	eax, cl
	add	eax, _b
	mov	_a, eax
	ENDM

H	MACRO 					;H(X,Y,Z) = X xor Y xor Z
	xor	eax, ecx			;eax = X
	xor	eax, edx			;ecx = Y
	ENDM					;edx = Z

;/* Let [abcd k s t] denote the operation a = b + ((a + H(b,c,d) + X[k] + T[i]) <<< s). */
HH	MACRO	_a, _b, _c, _d, xk, s, ti	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	H
	add	eax, _a
	add	eax, xk
	add	eax, ti
	mov	ecx, s
	rol	eax, cl
	add	eax, _b
	mov	_a, eax
	ENDM

I	MACRO 					;I(X,Y,Z) = Y xor (X v not(Z))
	not	edx				;eax = X
	or	eax, edx			;ecx = Y
	xor	eax, ecx			;edx = Z
	ENDM

;/* Let [abcd k s t] denote the operation a = b + ((a + I(b,c,d) + X[k] + T[i]) <<< s). */
II	MACRO	_a, _b, _c, _d, xk, s, ti	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	I
	add	eax, _a
	add	eax, xk
	add	eax, ti
	mov	ecx, s
	rol	eax, cl
	add	eax, _b
	mov	_a, eax
	ENDM

;*******************************************************************
;* MD5_Init                                                        *
;*******************************************************************
MD5_Init	proc
	mov	dword ptr [a], 067452301h	; 
	mov	dword ptr [b], 0EFCDAB89h	;chaining
	mov	dword ptr [c], 098BADCFEh	;variables
	mov	dword ptr [d], 010325476h	;
	ret
MD5_Init	endp

;*******************************************************************
;* MD5_Pad - Pad out to 56 mod 64                                  *
;* - buffer: data buffer					   *
;* - len : length (in bytes of the buffer)			   *
;*******************************************************************
MD5_Pad	proc	buffer:dword, len:dword
		local	lenmod: dword
		local	endlen: dword
	mov	ecx, len
	mov	eax, ecx
	shr	eax, 6		;64 bytes = one 512-bit block
	mov	nbloop, eax	;(located at offset buffer)
	mov	eax, 56d
	and	ecx, 3Fh
	.if	(ecx<56d)
	 mov	lastblock_use,1 ;1 * 512-bit block is needed (offset lastblock)
	 mov	endlen, 56d	;store length at "dword ptr [lastblock+56d]" and "dword ptr [lastblock+60d]"
	.else
	 mov	lastblock_use,2	;2 * 512-bit block is needed (offset lastblock)
	 add	eax, 64d
	 mov	endlen, 120d	;store length at "dword ptr [lastblock+120d]" and "dword ptr [lastblock+124d]"
	.endif	
	sub	eax, ecx	;number of byte of padding (0x80 ..)	 
	mov	lenmod, ecx	;len mod 64

	;we are now making the lastbock (offset lastblock)
	mov	esi, buffer
	mov	edi, offset lastblock
	mov	ecx, nbloop
	add	ecx ,ecx
	mov	edx, ecx
	add	edx, edx
	lea	ecx, [2*ecx+edx]
	lea	esi, [8*ecx+esi]	;esi = buffer + 64*nbloop

	push	eax			;number of byte of padding (0x80 ..)
	call	RtlMoveMemory, edi, esi, lenmod
	add	edi, lenmod
	call	RtlMoveMemory, edi, offset padding	;last arg is already on the stack	
	;
	mov	ecx, len		;64-bit representation of "len"
	mov	edx, ecx
	and	edx, 0E0000000h		;save the 3 highest bits
	bswap	edx
	shl	ecx, 3			;len is in bytes, it's now in bits
	mov	dword ptr [lengt], ecx
	mov	dword ptr [lengt+4], edx
	;
	mov	edx, endlen
	mov	eax, dword ptr [lengt+0]
	mov	ecx, dword ptr [lengt+4]
	mov	dword ptr [lastblock+edx], eax
	mov	dword ptr [lastblock+edx+4], ecx
	ret
MD5_Pad	endp

;*******************************************************************
;* MD5_Transform - the main algo (uses eax, ecx, edx)              *
;*  - in edi : 512-bit block					   *
;*******************************************************************
MD5_Transform	proc
	push	dword ptr [a]
	pop	dword ptr [save_a]
	push	dword ptr [b]
	pop	dword ptr [save_b]
	push	dword ptr [c]
	pop	dword ptr [save_c]
	push	dword ptr [d]
	pop	dword ptr [save_d]
;/* Round 1. */ /* Do the following 16 operations. */
	FF a,b,c,d, [edi+00h], S11, 0D76AA478h
	FF d,a,b,c, [edi+04h], S12, 0E8C7B756h
	FF c,d,a,b, [edi+08h], S13, 0242070DBh
	FF b,c,d,a, [edi+0Ch], S14, 0C1BDCEEEh
	FF a,b,c,d, [edi+10h], S11, 0F57C0FAFh
	FF d,a,b,c, [edi+14h], S12, 04787C62Ah
	FF c,d,a,b, [edi+18h], S13, 0A8304613h
	FF b,c,d,a, [edi+1Ch], S14, 0FD469501h
	FF a,b,c,d, [edi+20h], S11, 0698098D8h
	FF d,a,b,c, [edi+24h], S12, 08B44F7AFh
	FF c,d,a,b, [edi+28h], S13, 0FFFF5BB1h
	FF b,c,d,a, [edi+2Ch], S14, 0895CD7BEh
	FF a,b,c,d, [edi+30h], S11, 06B901122h
	FF d,a,b,c, [edi+34h], S12, 0FD987193h
	FF c,d,a,b, [edi+38h], S13, 0A679438Eh
	FF b,c,d,a, [edi+3Ch], S14, 049B40821h
;/* Round 2. */ /* Do the following 16 operations. */
	GG a,b,c,d, [edi+04h], S21, 0F61E2562h
	GG d,a,b,c, [edi+18h], S22, 0C040B340h
	GG c,d,a,b, [edi+2Ch], S23, 0265E5A51h
	GG b,c,d,a, [edi+00h], S24, 0E9B6C7AAh
	GG a,b,c,d, [edi+14h], S21, 0D62F105Dh
	GG d,a,b,c, [edi+28h], S22, 002441453h
	GG c,d,a,b, [edi+3Ch], S23, 0D8A1E681h
	GG b,c,d,a, [edi+10h], S24, 0E7D3FBC8h
	GG a,b,c,d, [edi+24h], S21, 021E1CDE6h
	GG d,a,b,c, [edi+38h], S22, 0C33707D6h
	GG c,d,a,b, [edi+0Ch], S23, 0F4D50D87h
	GG b,c,d,a, [edi+20h], S24, 0455A14EDh
	GG a,b,c,d, [edi+34h], S21, 0A9E3E905h
	GG d,a,b,c, [edi+08h], S22, 0FCEFA3F8h
	GG c,d,a,b, [edi+1Ch], S23, 0676F02D9h
	GG b,c,d,a, [edi+30h], S24, 08D2A4C8Ah
;/* Round 3. */ /* Do the following 16 operations. */	
	HH a,b,c,d, [edi+14h], S31, 0FFFA3942h
	HH d,a,b,c, [edi+20h], S32, 08771F681h
	HH c,d,a,b, [edi+2Ch], S33, 06D9D6122h
	HH b,c,d,a, [edi+38h], S34, 0FDE5380Ch
	HH a,b,c,d, [edi+04h], S31, 0A4BEEA44h
	HH d,a,b,c, [edi+10h], S32, 04BDECFA9h
	HH c,d,a,b, [edi+1Ch], S33, 0F6BB4B60h
	HH b,c,d,a, [edi+28h], S34, 0BEBFBC70h
	HH a,b,c,d, [edi+34h], S31, 0289B7EC6h
	HH d,a,b,c, [edi+00h], S32, 0EAA127FAh
	HH c,d,a,b, [edi+0Ch], S33, 0D4EF3085h
	HH b,c,d,a, [edi+18h], S34, 004881D05h
	HH a,b,c,d, [edi+24h], S31, 0D9D4D039h
	HH d,a,b,c, [edi+30h], S32, 0E6DB99E5h
	HH c,d,a,b, [edi+3Ch], S33, 01FA27CF8h
	HH b,c,d,a, [edi+08h], S34, 0C4AC5665h
;/* Round 4. */ /* Do the following 16 operations. */
	II a,b,c,d, [edi+00h], S41, 0F4292244h
	II d,a,b,c, [edi+1Ch], S42, 0432AFF97h
	II c,d,a,b, [edi+38h], S43, 0AB9423A7h
	II b,c,d,a, [edi+14h], S44, 0FC93A039h
	II a,b,c,d, [edi+30h], S41, 0655B59C3h
	II d,a,b,c, [edi+0Ch], S42, 08F0CCC92h
	II c,d,a,b, [edi+28h], S43, 0FFEFF47Dh
	II b,c,d,a, [edi+04h], S44, 085845DD1h
	II a,b,c,d, [edi+20h], S41, 06FA87E4Fh
	II d,a,b,c, [edi+3Ch], S42, 0FE2CE6E0h
	II c,d,a,b, [edi+18h], S43, 0A3014314h
	II b,c,d,a, [edi+34h], S44, 04E0811A1h
	II a,b,c,d, [edi+10h], S41, 0F7537E82h
	II d,a,b,c, [edi+2Ch], S42, 0BD3AF235h
	II c,d,a,b, [edi+08h], S43, 02AD7D2BBh
	II b,c,d,a, [edi+24h], S44, 0EB86D391h
;
	mov	eax, save_a
	add	a, eax
	mov	eax, save_b
	add	b, eax
	mov	eax, save_c
	add	c, eax
	mov	eax, save_d
	add	d, eax
	ret
MD5_Transform	endp

;*******************************************************************
;* MD5_Compute - result (offset): eax      		  	   *
;*******************************************************************
MD5_Compute	proc	buffer:dword, len:dword
		public	MD5_Compute
	call	MD5_Init
	call	MD5_Pad, buffer, len
	mov	edi, buffer
	mov	esi, nbloop
md5_loop:
	test	esi, esi
	jz	md5_loop_end
	call	MD5_Transform
	add	edi, 64d
	dec	esi
	jmp	md5_loop
md5_loop_end:

	mov	edi, offset lastblock	
	mov	esi, lastblock_use
md5_loop2:
	test	esi, esi
	jz	md5_loop_end2
	call	MD5_Transform		;don't use esi
	add	edi, 64d
	dec	esi
	jmp	md5_loop2
md5_loop_end2:

	mov	ecx, 4		;we have to bswap 4 dwords (if we want to use wsprintf %08X..)
	mov	eax, offset a
	ret
MD5_Compute	endp

;*******************************************************************
;* MD5_Test -						  	   *
;*******************************************************************
;test0	db 0
;test0size = 0		;MD5 ("") = D41D8CD98F00B204E9800998ECF8427E
;test1	db "a"
;test1size = 1		;MD5 ("a") = 0CC175B9C0F1B6A831C399E269772661
;test2	db "abc"
;test2size = 3		;MD5 ("abc") = 900150983CD24FB0D6963F7D28E17F72
;test3	db "12345678901234567890123456789012345678901234567890123456789012345678901234567890"
;test3size = 80		;MD5 ("12345678901234567890123456789012345678901234567890123456789012345678901234567890") = 57EDF4A22BE3C955AC49DA2E2107B67A
;
;main:					;the code begins here !
;	call	MD5_Compute, offset test3, test3size
;	call	ExitProcess, 0		;End (exit) program
;	end main			;end of code
